function ArkInventory.TooltipShowCustom( tooltip, arg1, arg2, arg3 )
	
	if not tooltip or ArkInventory.Global.Mode.Combat then return end
	
	if not tooltip:IsVisible( ) then
		-- dont add stuff to tooltips until after they become visible for the first time
		return
	end
	
	local h = nil
	
	if not h and tooltip["GetItem"] then
		h = select( 2, tooltip:GetItem( ) )
	end
	
	if not h and tooltip["GetSpell"] then
		h = select( 3, tooltip:GetSpell( ) )
		if h then
			h = GetSpellLink( h )
		end
	end
	
	if not h and arg1 then
		--h = select( 2, ArkInventory.ObjectInfo( arg1 ) )
	end

	if not h then return end
	
	ArkInventory.OutputDebug( "tooltip = ", tooltip:GetName( ), ", item = ", h )

--	if ArkInventory.db.global.option.tooltip.add.vendor then
--		ArkInventory.TooltipAddVendor( tooltip, h )
--	end
	
	if ArkInventory.db.global.option.tooltip.add.count then
		ArkInventory.TooltipAddItemCount( tooltip, h )
	end
	
--	if ArkInventory.db.global.option.tooltip.add.ilvl then
--		ArkInventory.TooltipAddItemLevel( tooltip, h )
--	end
	
	--ArkInventory.TooltipAddItemAge( tooltip, h, arg1, arg2 )
	
	tooltip:Show( )
	
end

function ArkInventory.TooltipAddEmptyLine( tooltip )
	
	if ArkInventory.db.global.option.tooltip.add.empty then
		tooltip:AddLine( " ", 1, 1, 1, 0 )
	end
	
end

function ArkInventory.TooltipAddItemCount( tooltip, h )
	
	local tt = ArkInventory.TooltipObjectCountGet( h )
	if tt then
		local tc = ArkInventory.db.global.option.tooltip.colour.count
		ArkInventory.TooltipAddEmptyLine( tooltip )
		tooltip:AddLine( tt, tc.r, tc.g, tc.b, 0 )
	end

end

function ArkInventory.TooltipAddItemLevel( tooltip, h )
	
	local tt = select( 6, ArkInventory.ObjectInfo( h ) )
	if tt then
		ArkInventory.TooltipAddEmptyLine( tooltip )
		tt = string.format( ArkInventory.Localise["TOOLTIP_ITEMLEVEL"], tt )
		tooltip:AddLine( tt, 1, 1, 1, 0 )
	end

end

function ArkInventory.TooltipAddItemAge( tooltip, h, bliz_id, slot_id )
	
	if type( bliz_id ) == "number" and type( slot_id ) == "number" then
		ArkInventory.TooltipAddEmptyLine( tooltip )
		local bag_id = ArkInventory.BagID_Internal( bliz_id )
		tooltip:AddLine( tt, 1, 1, 1, 0 )
	end

end

function ArkInventory.TooltipAddVendor( tooltip, h )

	if ArkInventory.Global.Mode.Merchant then
		return
	end
	
	local class, id = ArkInventory.ObjectStringDecode( h )
	
	if class ~= "item" then
		return
	end

	local price_per = select( 11, GetItemInfo( h ) )
	
	local tc = ArkInventory.db.global.option.tooltip.colour.vendor
	
	if price_per == nil then
	
		--tooltip:AddDoubleLine( ArkInventory.Localise["TOOLTIP_VENDOR"], ArkInventory.Localise["STATUS_NO_DATA"], tc.r, tc.g, tc.b, tc.r, tc.g, tc.b )
		return
		
	elseif price_per == 0 then
	
		if not ArkInventory.Global.Mode.Merchant then
			--tooltip:AddLine( ITEM_UNSELLABLE, tc.r, tc.g, tc.b )
			ArkInventory.TooltipAddEmptyLine( tooltip )
			ArkInventory.TooltipSetMoneyText( tooltip, 0, string.format( "%s:", ArkInventory.Localise["TOOLTIP_VENDOR"] ), tc.r, tc.g, tc.b )
		end
		
	elseif price_per > 0 then
	
		local count = 1
		
		if tooltip:GetOwner( ) and tooltip:GetOwner( ).count ~= nil then
			
			count = tonumber( tooltip:GetOwner( ).count )
			
			if type( count ) ~= "number" then
				count = 1
			end
			
			if count < 1 then
				count = 1
			end
			
		end
		
		local price = price_per * count
		
		if count == 1 then
			ArkInventory.TooltipAddEmptyLine( tooltip )
			ArkInventory.TooltipSetMoneyText( tooltip, price, string.format( "%s:", ArkInventory.Localise["TOOLTIP_VENDOR"], count ), tc.r, tc.g, tc.b )
		else
			ArkInventory.TooltipAddEmptyLine( tooltip )
			ArkInventory.TooltipSetMoneyText( tooltip, price, string.format( "%s: (%d @ %s)", ArkInventory.Localise["TOOLTIP_VENDOR"], count, ArkInventory.MoneyText( price_per ) ), tc.r, tc.g, tc.b )
		end
		
	else

		return
	
	end
	
end

function ArkInventory.TooltipObjectCountGet( search_id )
	
	local tc = ArkInventory.ObjectCountGet( search_id, ArkInventory.db.global.option.tooltip.me )
	if tc == nil then
		--ArkInventory.OutputDebug("no count data")
		return nil
	end
	
	local paint = ArkInventory.db.global.option.tooltip.colour.class
	local numcol = ""
	if paint then
		numcol = "|cffffffff"
	end
	
	local n = UnitName( "player" )
	
	local item_count_total = 0
	
	local character_count = 0
	local character_entries = { }
	
	local guild_count = 0
	local guild_entries = { }
	
	for pid, td in pairs( tc ) do
		
		local pd = ArkInventory.PlayerInfoGet( pid )
		
		local name = pd.info.name
		if paint then
			name = ArkInventory.DisplayName3( pd.info )
		end
		
		local item_count_character = 0
		local item_count_guild = 0
		
		local location_entries = { }
		
		if td.location then
			
			for l, lc in pairs( td.location ) do
				
				if lc > 0 then
					
					if l == ArkInventory.Const.Location.Vault then
						tinsert( location_entries, string.format( "%s", ArkInventory.Global.Location[l].Name ) )
						item_count_guild = item_count_guild + lc
					else
						tinsert( location_entries, string.format( "%s %s%s|r", ArkInventory.Global.Location[l].Name, numcol, lc ) )
						item_count_character = item_count_character + lc
					end
					
				end
				
			end
			
			if item_count_character > 0 then
				
				local me = ""
				if cn == n then
					me = ArkInventory.Localise["TOOLTIP_COUNT_ME"]
				end
				
				tinsert( character_entries, string.format( "%s%s|r: %s%s|r (%s)", me, name, numcol, item_count_character, table.concat( location_entries, ", " ) ) )
				character_count = character_count + 1
				item_count_total = item_count_total + item_count_character
				
			end
			
			if item_count_guild > 0 then
				tinsert( guild_entries, string.format( "%s|r: %s%s|r (%s)", name, numcol, item_count_guild, table.concat( location_entries, ", " ) ) )
				guild_count = guild_count + 1
			end
			
		end
		
	end

	if item_count_total > 0 or guild_count > 0 then
		
		local c = ""
		local g = ""
		
		if character_count > 1 then
			--table.sort( character_entries )
			c = string.format( "%s\n%s: %s%s|r", table.concat( character_entries, "\n" ), ArkInventory.Localise["TOOLTIP_TOTAL"], numcol, item_count_total )
		else
			c = table.concat( character_entries, "\n" )
		end
		
		if guild_count > 0 then
			--table.sort( guild_entries )
			g = string.format( "%s\n", table.concat( guild_entries, "\n" ) )
		end
		
		return string.format( "%s%s", g, c )
		
	else
		
		return nil
		
	end
	
end
